unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, VirtualTrees, Forms, Controls, Graphics, Dialogs, StdCtrls, LMessages;

type
  PNodeData = ^TNodeData;
  TNodeData = packed record
    s: String;
  end;

  TMyCheckBox = class(TCheckBox)
  public
    procedure WMPaint(var Msg: TLMPaint); message LM_PAINT;
  end;

  TForm1 = class(TForm)
    VST: TVirtualStringTree;
    procedure FormCreate(Sender: TObject);
    procedure VSTGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: String);
  private
    fCheckbox: TMyCheckBox;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  n, root: PVirtualNode;
  d: PNodeData;
  i: Integer;
begin
  VST.NodeDataSize := SizeOf(TNodeData);

  root := VST.AddChild(nil);
  d := VST.GetNodeData(root);
  d^.s := 'root';

  for i := 1 to 10 do begin
    n := VST.AddChild(root);
    d := VST.GetNodeData(n);
    d^.s := Format('node %d', [i]);
  end;

  fCheckbox := TMyCheckBox.Create(VST);
  fCheckbox.AutoSize    := false;
  fCheckbox.BoundsRect  := Classes.Rect(200, 10, 250, 60);
  fCheckbox.BorderStyle := bsSingle;
  fCheckbox.Parent      := VST;
end;

procedure TForm1.VSTGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: String);
begin
  CellText := PNodeData(Sender.GetNodeData(Node))^.s;
end;

procedure TMyCheckBox.WMPaint(var Msg: TLMPaint);
var
  StartTime: QWord;
begin
  // if this is called VirtualTreeview is painted with the wrong rect
  StartTime := GetTickCount64;
  inherited WMPaint(Msg);
  StartTime := GetTickCount64 - StartTime;
  if (StartTime > 0) then
    Form1.Caption := Format('CurrentTime: %d; DrawTime: %d', [ GetTickCount64, StartTime ]);
end;

end.

